package cp;

import cp.db.DB;

import java.sql.Connection;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.Vector;

public class Clubs extends Vector<Club> {
  
  public Clubs() {}
    
  public void load() throws SQLException {
    Connection conn = DB.getConnection();
    Statement s = conn.createStatement();
    String sql = "SELECT * FROM clubs " + "ORDER BY club";
    ResultSet rs = s.executeQuery(sql);
    clear();
    while (rs.next()) {
      Club club = new Club();
      club.load(rs);
      this.add(club);
    }
    rs.close();
    s.close();
  }
  
  public void addToDB(String club) throws SQLException {
    Connection conn = DB.getConnection();
    String sql = "INSERT INTO clubs " + 
                 "(club, chess4members) " + 
                 "VALUES (?,?)";
    PreparedStatement s = conn.prepareStatement(sql);
    s.setString(1, club);
    s.setInt(2, 20);
    try {
      s.execute();
      conn.commit();
    }
    catch (SQLException e) {
      conn.rollback();
      throw e;
    }
    s.close();
    load();
  }

  public void removeFromDB(Club club) throws SQLException {
    Connection conn = DB.getConnection();
    String sql = "DELETE FROM clubs " + 
                 "WHERE index = ?";
    PreparedStatement s = conn.prepareStatement(sql);
    s.setInt(1, club.getIndex());
    try {
      s.execute();
      conn.commit();
    }
    catch (SQLException e) {
      conn.rollback();
      throw e;
    }
    s.close();
    load();
  }
  
  public Club getClub(String name) {
    for (int i=0; i<size(); i++) {
      Club club = get(i);
      if (club.toString().equalsIgnoreCase(name)) {
        return club;
      }
    }
    return null;
  }

  Club getClub(int index) {
    for (int i=0; i<size(); i++) {
      Club club = get(i);
      if (club.getIndex()== index) {
        return club;
      }
    }
    return null;
  }

  void clearPlayers() {
    for (int i=0; i<size(); i++) {
      get(i).clearPlayers();
    }
  }
}
