package cp.gui;

import cp.Club;
import cp.Clubs;
import cp.Player;
import cp.db.Settings;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Font;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.Rectangle;
import java.awt.SystemColor;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.Date;
import java.sql.SQLException;
import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JTextPane;
import javax.swing.border.EtchedBorder;

public class EditPlayerPanel extends JPanel {
	private GridBagLayout gridBagLayout1 = new GridBagLayout();
	private JLabel jLabel9 = new JLabel();
	private JLabel jLabel5 = new JLabel();
	private JTextField jTextFieldFirstName = new JTextField();
	private JLabel jLabel6 = new JLabel();
	private JTextField jTextFieldLastName = new JTextField();
	private JLabel jLabel7 = new JLabel();
	private JComboBox jComboBoxClub = new JComboBox();
	private JPanel jPanelClub = new JPanel();
	private JButton jButtonAddClub = new JButton();
	private JButton jButtonRemoveClub = new JButton();
	private JLabel jLabel8 = new JLabel();
	private JTextField jTextFieldRatingN = new JTextField();
	private JTextField jTextFieldGroup = new JTextField();
	private JLabel jLabel12 = new JLabel();
	private JTextField jTextFieldTitle = new JTextField();
	private JLabel jLabel10 = new JLabel();
	private JPanel jPanelFIDE = new JPanel();
	private GridBagLayout gridBagLayout3 = new GridBagLayout();
	private JLabel jLabel13 = new JLabel();
	private JTextField jTextFieldRatingI = new JTextField();
	private JLabel jLabel14 = new JLabel();
	private JComboBox jComboBoxSex = new JComboBox();
	private JLabel jLabel15 = new JLabel();
	private JTextField jTextFieldFederation = new JTextField();
	private JLabel jLabel16 = new JLabel();
	private JTextField jTextFieldFideNr = new JTextField();
	private JLabel jLabel17 = new JLabel();
	private JTextField jTextFieldBirthdate = new JTextField();
	private JPanel jPanelPlayerSettings = new JPanel();
	private GridBagLayout gridBagLayout4 = new GridBagLayout();
	private JTextField jTextFieldManualTiebreak = new JTextField();
	private JLabel jLabel18 = new JLabel();
	private JTextField jTextFieldWithdrawn = new JTextField();
	private JLabel jLabel20 = new JLabel();
	private JTextPane jTextPane1 = new JTextPane();
	private JPanel jPanelOK = new JPanel();
	private JButton jButtonNew = new JButton();
	private JButton jButtonAdd = new JButton();
	private FlowLayout flowLayout1 = new FlowLayout();

	private Player player;
	private Settings settings;
	private PlayerEditor editor;
	private JPanel jPanel1 = new JPanel();

	public EditPlayerPanel() {
		try {
			jbInit();
		}
		catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	public void init(Settings settings, PlayerEditor editor) {
	  this.settings = settings;
	  this.editor = editor;
		jComboBoxSex.addItem(null);
		jComboBoxSex.addItem("M");
		jComboBoxSex.addItem("K");
		jPanelPlayerSettings.setVisible(editor.showTournamentInfo());
	}

	private void jbInit() throws Exception {
		this.setLayout(gridBagLayout1);
    jLabel9.setText("Skapa eller editera spelare");
		jLabel9.setFont(new Font("Tahoma", 1, 11));
		jLabel5.setText("Frnamn");
		jTextFieldFirstName.setPreferredSize(new Dimension(150, 19));
		jTextFieldFirstName.setSize(new Dimension(150, 19));
		jLabel6.setText("Efternamn");
		jLabel7.setText("Klubb");
		jButtonAddClub.setText("Lgg till klubb");
		jButtonAddClub.setMargin(new Insets(1, 5, 1, 5));
		jButtonAddClub.setFocusable(false);
		jButtonAddClub.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonAddClub_actionPerformed();
			}
		});
		jButtonRemoveClub.setText("Ta bort");
		jButtonRemoveClub.setMargin(new Insets(1, 5, 1, 5));
		jButtonRemoveClub.setFocusable(false);
		jButtonRemoveClub.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonRemoveClub_actionPerformed();
			}

		});
		jLabel8.setText("Rating");
		jTextFieldRatingN.setPreferredSize(new Dimension(40, 19));
		jTextFieldGroup.setPreferredSize(new Dimension(40, 19));
		jLabel12.setText("Grupp");
		jTextFieldTitle.setPreferredSize(new Dimension(30, 20));
		jTextFieldTitle.setColumns(3);
		jLabel10.setText("Titel");
		jPanelFIDE.setBorder(BorderFactory.createTitledBorder("FIDE-information"));
		jPanelFIDE.setLayout(gridBagLayout3);
		jLabel13.setText("Rating ELO");
		jTextFieldRatingI.setPreferredSize(new Dimension(40, 19));
		jLabel14.setText("Kn");
		jLabel15.setText("Federation");
		jTextFieldFederation.setColumns(3);
		jLabel16.setText("FIDE-nummer");
		jTextFieldFideNr.setColumns(11);
		jLabel17.setText("Fdelsedag (YYYY-MM-DD)");
		jTextFieldBirthdate.setColumns(10);
		jPanelPlayerSettings.setBorder(BorderFactory.createTitledBorder("Spelarinstllningar i turneringen"));
		jPanelPlayerSettings.setLayout(gridBagLayout4);
		jTextFieldManualTiebreak.setPreferredSize(new Dimension(24, 20));
		jTextFieldManualTiebreak.setToolTipText("Fr att manuellt srskilja spelare, stt vrdet till hgre n motstndaren och vlj manuell srskiljning i turneringen.");
		jLabel18.setText("Manuell srskiljning");
		jTextFieldWithdrawn.setPreferredSize(new Dimension(24, 20));
		jTextFieldWithdrawn.setToolTipText("Spelare kommer inte att lottas in i denna rond eller senare. Tomt flt eller 0 = ej utgtt");
		jLabel20.setText("Utg frn rond");
		jTextPane1.setEditable(false);
		jTextPane1.setBorder(BorderFactory.createEtchedBorder(EtchedBorder.LOWERED));
		jTextPane1.setText("Not: Spelare frn spelarpoolen KOPIERAS in i turneringen. \nDet betyder att editera en turneringsspelare pverkar inte spelaren i spelarpoolen.\nOm du skapar en spelare hr lggs den inte till i spelarpoolen.");
		jTextPane1.setBackground(SystemColor.info);
		jTextPane1.setPreferredSize(new Dimension(30, 60));
		jPanelOK.setLayout(flowLayout1);
		jButtonNew.setText("Ny spelare");
		jButtonNew.setEnabled(false);
		jButtonNew.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonNew_actionPerformed();
			}
		});
		jButtonAdd.setText("Spara spelare");
		jButtonAdd.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				jButtonAdd_actionPerformed();
			}
		});
		this.add(jLabel9, new GridBagConstraints(0, 0, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 10, 0), 0, 0));
		this.add(jLabel5, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.add(jTextFieldFirstName, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 3, 0, 0), 0, 0));
		this.add(jLabel6, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		this.add(jTextFieldLastName, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 3, 0, 0), 0, 0));
		this.add(jLabel7, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		this.add(jComboBoxClub, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 3, 0, 0), 0, 0));
		jPanelClub.add(jButtonAddClub, null);
		jPanelClub.add(jButtonRemoveClub, null);
		this.add(jPanelClub, new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0, GridBagConstraints.EAST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.add(jLabel8, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		this.add(jTextFieldRatingN, new GridBagConstraints(1, 5, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 3, 0, 0), 0, 0));
		this.add(jTextFieldGroup, new GridBagConstraints(1, 7, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 3, 3, 0), 0, 0));
		this.add(jLabel12, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		this.add(jTextFieldTitle, new GridBagConstraints(1, 6, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 3, 0, 0), 0, 0));
		this.add(jLabel10, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		jPanelFIDE.add(jLabel13, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 2, 0, 0), 0, 0));
		jPanelFIDE.add(jTextFieldRatingI, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		jPanelFIDE.add(jLabel14, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 2, 0, 0), 0, 0));
		jPanelFIDE.add(jComboBoxSex, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		jPanelFIDE.add(jLabel15, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 2, 0, 0), 0, 0));
		jPanelFIDE.add(jTextFieldFederation, new GridBagConstraints(1, 2, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		jPanelFIDE.add(jLabel16, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 2, 0, 0), 0, 0));
		jPanelFIDE.add(jTextFieldFideNr, new GridBagConstraints(1, 3, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		jPanelFIDE.add(jLabel17, new GridBagConstraints(0, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 2, 0, 0), 0, 0));
		jPanelFIDE.add(jTextFieldBirthdate, new GridBagConstraints(1, 4, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		this.add(jPanelFIDE, new GridBagConstraints(0, 8, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
		jPanelPlayerSettings.add(jTextFieldManualTiebreak, new GridBagConstraints(1, 1, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
		jPanelPlayerSettings.add(jLabel18, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 2, 0, 0), 0, 0));
		jPanelPlayerSettings.add(jTextFieldWithdrawn, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		jPanelPlayerSettings.add(jLabel20, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 2, 0, 12), 0, 0));
		this.add(jPanelPlayerSettings, new GridBagConstraints(0, 9, 2, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
		this.add(jTextPane1, new GridBagConstraints(0, 10, 2, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
		jPanelOK.add(jButtonNew, null);
		jPanelOK.add(jButtonAdd, null);
		this.add(jPanelOK, new GridBagConstraints(0, 11, 2, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		this.add(jPanel1, new GridBagConstraints(0, 12, 2, 1, 0.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.VERTICAL, new Insets(0, 0, 0, 0), 0, 0));
    this.setMinimumSize(this.getPreferredSize());
	}
  
  JButton getDefaultButton() {
    return jButtonAdd;
  }

	void setPlayer(Player player) {
		this.player = player;
		if (player == null) {
			jTextFieldFirstName.setText("");
			jTextFieldLastName.setText("");
			jComboBoxClub.setSelectedIndex(-1);
			jTextFieldRatingN.setText("");
			jTextFieldTitle.setText("");
			jTextFieldGroup.setText("");
			jTextFieldRatingI.setText("");
			jComboBoxSex.setSelectedItem(null);
			jTextFieldFederation.setText("");
			jTextFieldFideNr.setText("");
			jTextFieldBirthdate.setText("");
			jTextFieldWithdrawn.setText("");
			jTextFieldManualTiebreak.setText("");
			jButtonNew.setEnabled(false);
			jButtonAdd.setText("Spara");
		}
		else {
			jTextFieldFirstName.setText(player.getFirstName());
			jTextFieldLastName.setText(player.getLastName());
			jComboBoxClub.setSelectedItem(player.getClub());
			if (player.getRatingN() > 0) {
				jTextFieldRatingN.setText(String.valueOf(player.getRatingN()));
			}
			else {
				jTextFieldRatingN.setText("");
			}
			jTextFieldGroup.setText(player.getGroup());
			jTextFieldTitle.setText(player.getTitle());
			// FIDE info
		  if (player.getRatingI() > 0) {
		    jTextFieldRatingI.setText(String.valueOf(player.getRatingI()));
		  }
		  else {
		    jTextFieldRatingI.setText("");
		  }
		  jComboBoxSex.setSelectedItem(player.getSex());
		  jTextFieldFederation.setText(player.getFederation());
			
		  if (player.getFideID() > 0) {
		    jTextFieldFideNr.setText(String.valueOf(player.getFideID()));
		  }
		  else {
		    jTextFieldFideNr.setText("");
		  }
			jTextFieldBirthdate.setText(player.getBirthdate() != null ? player.getBirthdate().toString() : "");
			// Tournament info
			if (editor.showTournamentInfo()) {
				if (player.getWithdrawnFromRound() > -1) {
					jTextFieldWithdrawn.setText(String.valueOf(player.getWithdrawnFromRound()));
				}
				else {
					jTextFieldWithdrawn.setText("");
				}
				jTextFieldManualTiebreak.setText(Integer.toString(player.getManualTiebreak()));
			}			
			jButtonNew.setEnabled(true);
			jButtonAdd.setText("Uppdatera");
		}
	}

	private void jButtonAddClub_actionPerformed() {
		String club = JOptionPane.showInputDialog(this, "Ange klubbnamn", "Skapa ny klubb", JOptionPane.QUESTION_MESSAGE);
		if ((club != null) && (club.length() > 0)) {
			try {
				Clubs clubs = settings.getClubs();
				clubs.addToDB(club);
				updateClubList();
				jComboBoxClub.setSelectedItem(clubs.getClub(club));
			}
			catch (SQLException f) {
				if (f.getMessage().contains("duplicate key value")) {
					JOptionPane.showMessageDialog(this, "Klubben finns redan", "Information", JOptionPane.INFORMATION_MESSAGE);
				}
				else {
					JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
				}
			}
		}
	}

	private void jButtonNew_actionPerformed() {
		setPlayer(null);
	}

	private void jButtonAdd_actionPerformed() {
		if (player == null) {
			player = new Player(settings);
		}
		player.setFirstName(jTextFieldFirstName.getText().trim());
		player.setLastName(jTextFieldLastName.getText().trim());
		if (player.toString().trim().isEmpty()) {
			JOptionPane.showMessageDialog(this, "Vnligen ge spelaren ett namn frst.", "Information", JOptionPane.INFORMATION_MESSAGE);
			return;
		}
		Club club = (Club)jComboBoxClub.getSelectedItem();
		player.setClub(club);
		player.setTitle(jTextFieldTitle.getText().trim());
		player.setGroup(jTextFieldGroup.getText().trim());
		try {
			player.setRatingN(Integer.parseInt(jTextFieldRatingN.getText()));
		}
		catch (NumberFormatException f) {
			if (!jTextFieldRatingN.getText().isEmpty()) {
				JOptionPane.showMessageDialog(this, "Kan inte omvandla rating till ett heltal: " + f.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
				return;
			}
			player.setRatingN(0);
		}
	  // FIDE info
	  try {
	    player.setRatingI(Integer.parseInt(jTextFieldRatingI.getText()));
	  }
	  catch (NumberFormatException f) {
	    if (!jTextFieldRatingI.getText().isEmpty()) {
	      JOptionPane.showMessageDialog(this, "Kan inte omvandla rating ELO till ett heltal: " + f.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
	      return;
	    }
	    player.setRatingI(0);
	  }
		player.setSex((String)jComboBoxSex.getSelectedItem());
		player.setFederation(jTextFieldFederation.getText().trim());
	  jTextFieldFederation.setText(player.getFederation());
	  
	  try {
	    player.setFIDENr(Integer.parseInt(jTextFieldFideNr.getText()));
	  }
	  catch (NumberFormatException f) {
	    if (!jTextFieldFideNr.getText().isEmpty()) {
	      JOptionPane.showMessageDialog(this, "Kan inte omvandla FIDE nr till ett heltal: " + f.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
	      return;
	    }
	    player.setFIDENr(0);
	  }
		try {
			player.setBirthdate(Date.valueOf(jTextFieldBirthdate.getText()));
		}
		catch (IllegalArgumentException e) {
		  if (!jTextFieldBirthdate.getText().isEmpty()) {
		    JOptionPane.showMessageDialog(this, "Kan inte omvandla fdelsedag till ett datum: " + e.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
		    return;
		  }
		  player.setBirthdate(null);
		}
		// Tournament info
		if (editor.showTournamentInfo()) {
			try {
				int value = Integer.parseInt(jTextFieldWithdrawn.getText());
				if (value > 0) {
					player.setWithdrawnFromRound(value);
				}
			}
			catch (NumberFormatException f) {
				if (!jTextFieldWithdrawn.getText().isEmpty()) {
					JOptionPane.showMessageDialog(this, "Kan inte omvandla utg frn rond till ett heltal: " + f.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
					return;
				}
				player.setWithdrawnFromRound(-1);
			}
			try {
				player.setManualTiebreak(Integer.parseInt(jTextFieldManualTiebreak.getText()));
			}
			catch (NumberFormatException f) {
				if (!jTextFieldManualTiebreak.getText().isEmpty()) {
					JOptionPane.showMessageDialog(this, "Kan inte omvandla manuell srskiljning till ett heltal: " + f.getMessage(), "Information", JOptionPane.INFORMATION_MESSAGE);
					return;
				}
				player.setManualTiebreak(0);
			}
		}
		try {
			if (jButtonAdd.getText().equalsIgnoreCase("Uppdatera")) {
				editor.update(player);
			}
			else {
				editor.add(player);
			}
		}
		catch (SQLException e) {
			if (e.getMessage().contains("duplicate key value")) {
				JOptionPane.showMessageDialog(this, "Spelaren finns redan.", "Information", JOptionPane.INFORMATION_MESSAGE);
			}
			else {
				JOptionPane.showMessageDialog(this, "SQL fel:" + e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
			}
		}
		setPlayer(null);
		jTextFieldFirstName.requestFocus();
	}

	private void jButtonRemoveClub_actionPerformed() {
		if (jComboBoxClub.getSelectedItem() != null) {
			if (JOptionPane.showConfirmDialog(this, "r du sker p att du vill ta bort den valda klubben?", "Bekrfta radera", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.OK_OPTION) {
				Clubs clubs = settings.getClubs();
				try {
					clubs.removeFromDB((Club)jComboBoxClub.getSelectedItem());
				}
				catch (SQLException f) {
					if (f.getMessage().contains("foreign key")) {
						JOptionPane.showMessageDialog(this, "En spelare spelar fr denna klubb. Du kan inte ta bort den.", "Information", JOptionPane.INFORMATION_MESSAGE);
					}
					else {
						JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
					}
				}
				updateClubList();
			}
		}
		else {
			JOptionPane.showMessageDialog(this, "Vlj en klubb att ta bort frst.", "Information", JOptionPane.INFORMATION_MESSAGE);
		}
	}

	void updateClubList() {
		jComboBoxClub.removeAllItems();
		jComboBoxClub.addItem(null);
		Clubs clubs = settings.getClubs();
		for (int i = 0; i < clubs.size(); i++) {
			jComboBoxClub.addItem(clubs.get(i));
		}
	}


}
