package cp.gui;

import cp.ChessPairerException;
import cp.ChessPairerInfoException;
import cp.Club;
import cp.Clubs;
import cp.Game;
import cp.Player;
import cp.Players;
import cp.Round;
import cp.Rounds;
import cp.Tournament;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import cp.db.DB;
import cp.db.Settings;
import cp.gui.web.*;
import cp.update.*;
import java.awt.*;
import java.awt.print.PrinterException;
import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileReader;
import java.io.FileWriter;
import java.io.IOException;
import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;
import java.util.NoSuchElementException;
import java.util.Scanner;
import java.util.Vector;
import javax.swing.*;
import javax.swing.JMenuItem;

public class MainFrame extends JFrame {
  private BorderLayout layoutMain = new BorderLayout();
  private JPanel panelCenter = new JPanel();
  private JMenuBar menuBar = new JMenuBar();
  private JMenu menuTournament = new JMenu();
  private JMenuItem menuFileExit = new JMenuItem();
  private JMenu menuHelp = new JMenu();
  private JMenuItem menuHelpAbout = new JMenuItem();
  private JLabel statusBar = new JLabel();
  private JMenuItem jMenuItemTournamentNew = new JMenuItem();
  private JMenuItem jMenuItemTournamentSettings = new JMenuItem();
  private JMenuItem jMenuItemTournamentDelete = new JMenuItem();
  private JMenu jMenu2 = new JMenu();
  private JMenuItem jMenuItemPairNext = new JMenuItem();
  private JMenuItem jMenuItemPrintPairing = new JMenuItem();
  private JMenuItem jMenuItemUnpair = new JMenuItem();
  private JMenu jMenu3 = new JMenu();
  private JMenuItem jMenuItemPrintStandings = new JMenuItem();
  private JMenu jMenu4 = new JMenu();
  private JPanel jPanel1 = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  private JLabel jLabel1 = new JLabel();
  private JLabel jLabel2 = new JLabel();
  private JComboBox jComboBoxTournaments = new JComboBox();
  private JComboBox jComboBoxGroups = new JComboBox();
  private DB db;
  private Settings settings;
  private Tournament currentTournament;
  private ItemListener jComboBoxGroupsItemListener = new ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            jComboBoxGroups_itemStateChanged();
          }
        };
  private ItemListener jComboBoxTournamentsItemListener = new ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            jComboBoxTournaments_itemStateChanged();
          }
        };
  private ItemListener jComboBoxRoundsItemListener = new ItemListener() {
          public void itemStateChanged(ItemEvent e) {
            jComboBoxRounds_itemStateChanged(e);
          }

  };
  private JMenuItem jMenuItem1 = new JMenuItem();
  private AvailablePlayersDlg availablePlayersDlg;
  private JMenuItem jMenuItemTournamentPlayers = new JMenuItem();
  private TournamentPlayersDialog tournamentPlayersDlg;
  private EditResultsPanel editResultsPanel;
  private AlphabeticalPairingPanel alphabeticalPairingPanel = new AlphabeticalPairingPanel();
  private StandingsPanel standingsPanel;
  private PlayerListPanel playerListPanel;
  private ClubStandingsPanel clubStandingsPanel = new ClubStandingsPanel();
  private Chess4SetupPanel chess4SetupPanel = new Chess4SetupPanel();
  private Chess4StandingsPanel chess4StandingsPanel = new Chess4StandingsPanel();
  private JMenuItem jMenuItemAppendPair = new JMenuItem();
  private JMenuItem jMenuItemDeletePair = new JMenuItem();
  private JLabel jLabel3 = new JLabel();
  private JComboBox jComboBoxRounds = new JComboBox();
  private JMenuItem jMenuItemEditPair = new JMenuItem();
  private JTabbedPane jTabbedPane = new JTabbedPane();
  private JMenuItem jMenuItemPublishStandings = new JMenuItem();
  private JMenuItem jMenuItemPublishPairing = new JMenuItem();
  private JMenu jMenu1 = new JMenu();
  private JMenuItem jMenuItemSettings = new JMenuItem();
  private JMenuItem jMenuItemPrintPlayerList = new JMenuItem();
  private JMenuItem jMenuItemPublishPlayerList = new JMenuItem();
  private JMenuItem jMenuItemPublishRounds = new JMenuItem();
  private JMenuItem jMenuItemPrintClubStandings = new JMenuItem();
  private JMenuItem jMenuItemPublishClubStandings = new JMenuItem();
  private JMenuItem jMenuItemPrintChess4Standings = new JMenuItem();
  private JMenuItem jMenuItemPublishChess4Standings = new JMenuItem();
  private JMenuItem jMenuItemImport = new JMenuItem();
  private JMenuItem jMenuItemExport = new JMenuItem();
  private JMenuItem jMenuItemPrintAlphabetical = new JMenuItem();
	private JMenuItem jMenuItemExportToLiveChess = new JMenuItem();
	private JMenu jMenu5 = new JMenu();
	private JMenuItem jMenuItemAlphabeticalPairing1 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing2 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing3 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing4 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing5 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing6 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing7 = new JMenuItem();
	private JMenuItem jMenuItemAlphabeticalPairing8 = new JMenuItem();
  protected Image icon;
  private JMenuItem jMenuItemReport = new JMenuItem();
  private MainFrame_AboutBoxPanel1 aboutPanel = new MainFrame_AboutBoxPanel1();
  private JMenuItem jMenuItemUpdate = new JMenuItem();

  public MainFrame() {
    try {
      try {
        db = new DB();
      }
      catch (SQLException e) {
        JOptionPane.showMessageDialog(this, "Kan inte ppna eller skapa en databas. SQL fel:" + e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
        System.exit(0);
      }
      settings = new Settings();
      editResultsPanel = new EditResultsPanel(this);
      playerListPanel = new PlayerListPanel(settings);
      standingsPanel = new StandingsPanel(settings);
      jbInit();
      // Fill tournament combo box with tournaments
      fillTournamentComboBox();
			Tournament tournament = settings.getLastTournament();
      if (tournament != null) {
        selectTournament(tournament);
      }
    }
    catch (SQLException e) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    catch (Exception e) {
      JOptionPane.showMessageDialog(this, "Fel:" + e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    updateStatus();
    
    // Check for updates
    if (settings.getSearchForUpdate()) {
      SwingUtilities.invokeLater(new Update(aboutPanel.getVersion(), settings, true));
    }
  }

  private void jbInit() throws Exception {
    this.setJMenuBar(menuBar);
    this.getContentPane().setLayout(layoutMain);
    panelCenter.setLayout(borderLayout1);
		this.setSize(new Dimension(600, 588));
    this.setTitle("Lotta");
    this.addWindowListener(new WindowAdapter() {
        public void windowClosing(WindowEvent e) {
          this_windowClosing();
        }
      });
    menuTournament.setText("Turnering");
    menuFileExit.setText("Avsluta");
    menuFileExit.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ae) {
          fileExit_ActionPerformed();
        }
      });
    menuHelp.setText("Hjlp");
    menuHelpAbout.setText("Om");
    menuHelpAbout.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent ae) {
          helpAbout_ActionPerformed();
        }
      });
    statusBar.setText("");
    jMenuItemTournamentNew.setText("Ny");
    jMenuItemTournamentNew.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemTournamentNew_actionPerformed();
        }
      });
    jMenuItemTournamentSettings.setText("Editera");
    jMenuItemTournamentSettings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemTournamentSettings_actionPerformed();
        }
      });
    jMenuItemTournamentDelete.setText("Ta bort");
    jMenuItemTournamentDelete.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemTournamentDelete_actionPerformed();
        }
      });
    jMenu2.setText("Lotta");
    jMenuItemPairNext.setText("Lotta nsta rond");
    jMenuItemPairNext.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPairNext_actionPerformed();
        }
      });
    jMenuItemPrintPairing.setText("Skriv ut lottning");
    jMenuItemPrintPairing.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPrintPairing_actionPerformed();
        }
      });
    jMenuItemUnpair.setText("ngra lottning");
    jMenuItemUnpair.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemUnpair_actionPerformed();
        }
      });
    jMenu3.setText("Stllning");
    jMenuItemPrintStandings.setText("Skriv ut stllning");
    jMenuItemPrintStandings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPrintStandings_actionPerformed();
        }
      });
    jMenu4.setText("Spelare");
    jPanel1.setLayout(gridBagLayout1);
    jPanel1.setBorder(BorderFactory.createTitledBorder("Aktiv turnering"));
    jLabel1.setText("Turnering:");
    jLabel2.setText("Grupp:");
    jComboBoxTournaments.addItemListener(jComboBoxTournamentsItemListener);
    jComboBoxGroups.addItemListener(jComboBoxGroupsItemListener);
    jMenuItem1.setText("Spelarpool");
    jMenuItem1.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItem1_actionPerformed();
        }
      });
    jMenuItemTournamentPlayers.setText("Turneringsspelare");
    jMenuItemTournamentPlayers.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemTournamentPlayers_actionPerformed();
        }
      });
    jMenuItemAppendPair.setText("Lgg till bord");
    jMenuItemAppendPair.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemAppendPair_actionPerformed();
        }
      });
    jMenuItemDeletePair.setText("Ta bort bord");
    jMenuItemDeletePair.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemDeletePair_actionPerformed();
        }
      });
    jLabel3.setText("Rond:");
    jMenuItemEditPair.setText("Editera bord");
    jMenuItemEditPair.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemEditPair_actionPerformed();
        }
      });
    jMenuItemPublishStandings.setText("Publicera stllning");
    jMenuItemPublishStandings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPublishStandings_actionPerformed();
        }
      });
    jMenuItemPublishPairing.setText("Publicera lottning");
    jMenuItemPublishPairing.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPublishPairing_actionPerformed();
        }
      });
    jMenu1.setText("Instllningar");
    jMenuItemSettings.setText("Instllningar");
    jMenuItemSettings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemSettings_actionPerformed();
        }
      });
    jMenuItemPrintPlayerList.setText("Skriv ut spelarlista");
    jMenuItemPrintPlayerList.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPrintPlayerList_actionPerformed();
        }
      });
    jMenuItemPublishPlayerList.setText("Publicera spelarlista");
    jMenuItemPublishPlayerList.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPublishPlayerList_actionPerformed();
        }
      });
    jMenuItemPublishRounds.setText("Publicera rond fr rond");
    jMenuItemPublishRounds.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPublishRounds_actionPerformed();
        }
      });
    jMenuItemPrintClubStandings.setText("Skriv ut klubbstllning");
    jMenuItemPrintClubStandings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPrintClubStandings_actionPerformed();
        }
      });
    jMenuItemPublishClubStandings.setText("Publicera klubbstllning");
    jMenuItemPublishClubStandings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPublishClubStandings_actionPerformed();
        }
      });
    jMenuItemPrintChess4Standings.setText("Skriv ut Schack4an-stllning");
    jMenuItemPrintChess4Standings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPrintChess4Standings_actionPerformed();
        }
      });
    jMenuItemPublishChess4Standings.setText("Publicera Schack4an-stllning");
    jMenuItemPublishChess4Standings.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPublishChess4Standings_actionPerformed();
        }
      });
    jMenuItemImport.setText("Importera");
    jMenuItemImport.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemImport_actionPerformed();
        }
      });
    jMenuItemExport.setText("Exportera");
    jMenuItemExport.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemExport_actionPerformed();
        }
      });
    jMenuItemPrintAlphabetical.setText("Skriv ut alfabetisk lottning");
    jMenuItemPrintAlphabetical.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemPrintAlphabetical_actionPerformed();
        }
      });
		jMenuItemExportToLiveChess.setText("Exportera till LiveChess");
		jMenuItemExportToLiveChess.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemExportToLiveChess_actionPerformed();
				}
			});
		jMenu5.setText("Publicera alfabetisk lottning");
		jMenuItemAlphabeticalPairing1.setText("1 kolumn");
		jMenuItemAlphabeticalPairing1.setActionCommand("");
		jMenuItemAlphabeticalPairing1.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(1);
				}
			});
		jMenuItemAlphabeticalPairing2.setText("2 kolumner");
		jMenuItemAlphabeticalPairing2.setActionCommand("jMenuItemAlphabeticalPairing2");
	  jMenuItemAlphabeticalPairing2.addActionListener(new ActionListener() {
	      public void actionPerformed(ActionEvent e) {
	        jMenuItemAlphabeticalPairing_actionPerformed(2);
	      }
	    });
		jMenuItemAlphabeticalPairing3.setText("3 kolumner");
		jMenuItemAlphabeticalPairing3.setActionCommand("jMenuItemAlphabeticalPairing3");
		jMenuItemAlphabeticalPairing3.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(3);
				}
			});
		jMenuItemAlphabeticalPairing4.setText("4 kolumner");
		jMenuItemAlphabeticalPairing4.setActionCommand("jMenuItemAlphabeticalPairing4");
		jMenuItemAlphabeticalPairing4.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(4);
				}
			});
		jMenuItemAlphabeticalPairing5.setText("5 kolumner");
		jMenuItemAlphabeticalPairing5.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(5);
				}
			});
		jMenuItemAlphabeticalPairing6.setText("6 kolumner");
		jMenuItemAlphabeticalPairing6.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(6);
				}
			});
		jMenuItemAlphabeticalPairing7.setText("7 kolumner");
		jMenuItemAlphabeticalPairing7.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(7);
				}
			});
		jMenuItemAlphabeticalPairing8.setText("8 kolumner");
		jMenuItemAlphabeticalPairing8.addActionListener(new ActionListener() {
				public void actionPerformed(ActionEvent e) {
					jMenuItemAlphabeticalPairing_actionPerformed(8);
				}
			});
    jMenuItemReport.setText("Skapa FIDE-rapport");
    jMenuItemReport.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemReport_actionPerformed();
        }
      });
    jMenuItemUpdate.setText("Sk efter uppdateringar");
    jMenuItemUpdate.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jMenuItemUpdate_actionPerformed();
        }
      });
    menuTournament.add(jMenuItemTournamentNew);
    menuTournament.add(jMenuItemTournamentSettings);
    menuTournament.addSeparator();
    menuTournament.add(jMenuItemTournamentDelete);
//    menuTournament.addSeparator();
//    menuTournament.add(jMenuItemReport);
    menuTournament.addSeparator();
    menuTournament.add(menuFileExit);
    menuBar.add(menuTournament);
    jMenu2.add(jMenuItemPairNext);
    jMenu2.addSeparator();
    jMenu2.add(jMenuItemPrintPairing);
    jMenu2.add(jMenuItemPublishPairing);
    jMenu2.add(jMenuItemPrintAlphabetical);
    jMenu5.add(jMenuItemAlphabeticalPairing1);
    jMenu5.add(jMenuItemAlphabeticalPairing2);
    jMenu5.add(jMenuItemAlphabeticalPairing3);
    jMenu5.add(jMenuItemAlphabeticalPairing4);
    jMenu5.add(jMenuItemAlphabeticalPairing5);
    jMenu5.add(jMenuItemAlphabeticalPairing6);
    jMenu5.add(jMenuItemAlphabeticalPairing7);
    jMenu5.add(jMenuItemAlphabeticalPairing8);
    jMenu2.add(jMenu5);
    jMenu2.addSeparator();
    jMenu2.add(jMenuItemUnpair);
    jMenu2.addSeparator();
    jMenu2.add(jMenuItemExportToLiveChess);
    jMenu2.addSeparator();
    jMenu2.add(jMenuItemAppendPair);
    jMenu2.add(jMenuItemEditPair);
    jMenu2.add(jMenuItemDeletePair);
    menuBar.add(jMenu2);
    menuBar.add(jMenu3);
    jMenu4.add(jMenuItem1);
    jMenu4.add(jMenuItemTournamentPlayers);
    jMenu4.addSeparator();
    jMenu4.add(jMenuItemPrintPlayerList);
    jMenu4.add(jMenuItemPublishPlayerList);
    jMenu4.addSeparator();
    jMenu4.add(jMenuItemExport);
    jMenu4.add(jMenuItemImport);
    menuBar.add(jMenu4);
    jMenu1.add(jMenuItemSettings);
    menuBar.add(jMenu1);
    menuHelp.add(jMenuItemUpdate);
    menuHelp.add(menuHelpAbout);
    menuBar.add(menuHelp);
    jMenu3.add(jMenuItemPrintStandings);
    jMenu3.add(jMenuItemPublishStandings);
    jMenu3.addSeparator();
    jMenu3.add(jMenuItemPublishRounds);
    jMenu3.addSeparator();
    jMenu3.add(jMenuItemPrintClubStandings);
    jMenu3.add(jMenuItemPublishClubStandings);
    jMenu3.add(jMenuItemPrintChess4Standings);
    jMenu3.add(jMenuItemPublishChess4Standings);
    this.getContentPane().add(statusBar, BorderLayout.SOUTH);
    jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(1, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jComboBoxTournaments, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 20), 0, 0));
    jPanel1.add(jComboBoxGroups, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel3, new GridBagConstraints(2, 0, 1, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
    jPanel1.add(jComboBoxRounds, new GridBagConstraints(2, 1, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 10), 0, 0));
    panelCenter.add(jPanel1, BorderLayout.NORTH);
    this.getContentPane().add(panelCenter, BorderLayout.CENTER);
    jTabbedPane.addTab("Lottning & resultat", editResultsPanel);
    jTabbedPane.addTab("Alfabetisk lottning", alphabeticalPairingPanel);
    jTabbedPane.addTab("Stllning", standingsPanel);
    jTabbedPane.addTab("Spelare", playerListPanel);
    jTabbedPane.addTab("Klubbstllning", clubStandingsPanel);
    panelCenter.add(jTabbedPane, BorderLayout.CENTER);
    icon = Toolkit.getDefaultToolkit().getImage(getClass().getClassLoader().getResource("lotta.png"));
    this.setIconImage(icon);
	}

  void fileExit_ActionPerformed() {
    closeDB();
    System.exit(0);
  }

  void helpAbout_ActionPerformed() {
    JOptionPane.showMessageDialog(this, aboutPanel, "Om", JOptionPane.PLAIN_MESSAGE);
  }

  /**
   * User creates a new tournament
   */
  private void jMenuItemTournamentNew_actionPerformed() {
		TournamentDialog dlg = new TournamentDialog(settings, icon);
    dlg.setLocationRelativeTo(this);
    dlg.setVisible(true);
    try {
      fillTournamentComboBox();
			Tournament tournament = dlg.getTournament();
      if (tournament != null) {
        this.setCurrentTournament(tournament);
        this.selectTournament(tournament);
      }
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    catch (ChessPairerException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
  }

  /**
   * Sets the current tournament
   */
  private void setCurrentTournament(Tournament tournament) throws SQLException, ChessPairerException {
    this.currentTournament = tournament;
    // Save the choice to the database
    settings.setLastTournament(tournament);
    updateStatus();
    // Show rounds in rounds combobx
    jComboBoxRounds.removeItemListener(jComboBoxRoundsItemListener);
    jComboBoxRounds.removeAllItems();
		Rounds rounds = tournament.getRounds();
    for (int i=0; i<rounds.size(); i++) {
			Round round = rounds.get(i);
      jComboBoxRounds.addItem(round);
    }
    // Show results in editresultspanel
    setRound(tournament.getCurrentRound());
    playerListPanel.setTournament(tournament);
    jComboBoxRounds.addItemListener(jComboBoxRoundsItemListener);
    setChess4(tournament);
  }

  /**
   * Fills the tournaments combo box
   */
  private void fillTournamentComboBox() throws SQLException {
    jComboBoxTournaments.removeItemListener(jComboBoxTournamentsItemListener);
    jComboBoxGroups.removeItemListener(jComboBoxGroupsItemListener);
    jComboBoxRounds.removeItemListener(jComboBoxRoundsItemListener);
    Connection conn = DB.getConnection();
    Statement s = conn.createStatement();
    String sql = "SELECT distinct tournament FROM tournaments " +
                 "ORDER BY tournament ";
    ResultSet rs = s.executeQuery(sql);
    jComboBoxTournaments.removeAllItems();
    jComboBoxGroups.removeAllItems();
    jComboBoxRounds.removeAllItems();
    while (rs.next()) {
      jComboBoxTournaments.addItem(rs.getString("tournament"));
    }
    s.close();
    jComboBoxTournaments.addItemListener(jComboBoxTournamentsItemListener);
    jComboBoxGroups.addItemListener(jComboBoxGroupsItemListener);
    jComboBoxRounds.addItemListener(jComboBoxRoundsItemListener);
  }

  private void fillRoundsComboCox(Tournament tournament) {
    // Show rounds in rounds combobx
    jComboBoxRounds.removeItemListener(jComboBoxRoundsItemListener);
    jComboBoxRounds.removeAllItems();
		Rounds rounds = tournament.getRounds();
    for (int i=0; i<rounds.size(); i++) {
			Round round = rounds.get(i);
      jComboBoxRounds.addItem(round);
    }
    // Show results in editresultspanel
    try {
      setRound(tournament.getCurrentRound());
    }
    catch (SQLException e) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    catch (ChessPairerException e) {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    jComboBoxRounds.addItemListener(jComboBoxRoundsItemListener);
  
  }

  private void closeDB() {
    try {
      if (db != null) {
        db.close();
        db.closeDatabase();
      }
      
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(null, "Databasen kunde inte stnga ner normalt:" + f.getMessage(), "Databasfel", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jComboBoxTournaments_itemStateChanged() {
    Connection conn = DB.getConnection();
    try {
      Statement s = conn.createStatement();
      String sql = "SELECT distinct tournamentgroup FROM tournaments " +
                   "WHERE tournament = '" + jComboBoxTournaments.getSelectedItem() + "' " + 
                   "ORDER BY tournamentgroup ";
      ResultSet rs = s.executeQuery(sql);
      jComboBoxGroups.removeAllItems();
      while (rs.next()) {
        jComboBoxGroups.addItem(rs.getString("tournamentgroup"));
      }
      s.close();
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jComboBoxGroups_itemStateChanged() {
    // A tournament has been selected
		Tournament tournament = new Tournament(settings);
    try {
      tournament.load((String)jComboBoxTournaments.getSelectedItem(), (String)jComboBoxGroups.getSelectedItem());
      setCurrentTournament(tournament);
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    catch (ChessPairerException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
  }
  
  /**
   * Selects the tournament visually in the combo boxes
   */
  private void selectTournament(Tournament tournament) {
    if (jComboBoxTournaments.getSelectedItem().equals(tournament.getName())) {
      jComboBoxTournaments_itemStateChanged();
    }
    else {
      jComboBoxTournaments.setSelectedItem(tournament.getName());
    }
    jComboBoxGroups.setSelectedItem(tournament.getGroup());
  }
  
  private void jMenuItemTournamentDelete_actionPerformed() {
    if (JOptionPane.showConfirmDialog(this, "r du sker p att du vill ta bort turneringen " + currentTournament.toString() + "?", "Radera turnering", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE) == JOptionPane.OK_OPTION) {
      try {
        currentTournament.delete();
        currentTournament = null;
        fillTournamentComboBox();
        // Select the first tournament
        jComboBoxTournaments_itemStateChanged();
      }
      catch (SQLException f) {
        JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  /**
   * User selects to edit tournament settings
   */
  private void jMenuItemTournamentSettings_actionPerformed() {
    if (currentTournament != null) {
			TournamentDialog dlg = new TournamentDialog(settings, icon);
      dlg.setTournament(currentTournament);
      dlg.setLocationRelativeTo(this);
      dlg.setVisible(true);
    }
    setChess4(currentTournament);
    updatePanels();
  }

  private void jMenuItem1_actionPerformed() {
    if (availablePlayersDlg == null) {
      availablePlayersDlg = new AvailablePlayersDlg(settings, icon);
      availablePlayersDlg.setLocationRelativeTo(this);
    }
    availablePlayersDlg.setVisible(true);
    jTabbedPane.setSelectedIndex(3);
  }

  private void jMenuItemTournamentPlayers_actionPerformed() {
    if (currentTournament == null) {
      JOptionPane.showMessageDialog(this, "Ingen turnering vald", "Information", JOptionPane.INFORMATION_MESSAGE);
      return;
    }
    try {
      tournamentPlayersDlg = new TournamentPlayersDialog(settings, icon);
      tournamentPlayersDlg.setLocationRelativeTo(this);
      tournamentPlayersDlg.setTournament(currentTournament);
      tournamentPlayersDlg.setVisible(true);
      jTabbedPane.setSelectedIndex(3);
      // Update club standings and all other panels by setting the round again!
      setRound((Round)jComboBoxRounds.getSelectedItem());
      updatePanels();
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    catch (ChessPairerException f) {}
  }

  private void jMenuItemPairNext_actionPerformed() {
    if (currentTournament == null) {
      JOptionPane.showMessageDialog(this, "Ingen turnering vald", "Information", JOptionPane.INFORMATION_MESSAGE);
      return;
    }
    // Pair next round!
    try {
      currentTournament.pair();
      this.fillRoundsComboCox(currentTournament);
      jTabbedPane.setSelectedIndex(0);
    }
    catch (ChessPairerInfoException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Kan ej lotta.", JOptionPane.WARNING_MESSAGE);
    }
    catch (ChessPairerException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Kan ej lotta. Vnligen starta om programmet.", JOptionPane.ERROR_MESSAGE);
      System.exit(0);
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      System.exit(0);
    }
    catch (Exception f) {
      JOptionPane.showMessageDialog(this, "Programfel. Sprning:" + f.getStackTrace()[0], "Programfel", JOptionPane.ERROR_MESSAGE);
      System.exit(0);
    }
    updateStatus(); 
  }

  private void jMenuItemUnpair_actionPerformed() {
    if (JOptionPane.showConfirmDialog(this, "r du sker p att du vill ngra lottningen fr den senaste ronden? Om resultat finns s kommer de att tas bort.", "ngra lottning", JOptionPane.OK_CANCEL_OPTION, JOptionPane.WARNING_MESSAGE) == JOptionPane.OK_OPTION) {
      try {
        currentTournament.unpair();
        this.fillRoundsComboCox(currentTournament);
        this.setRound(currentTournament.getCurrentRound());
        this.updateStatus();
      }
      catch (SQLException f) {
        JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
      catch (ChessPairerException f) {
        JOptionPane.showMessageDialog(this, f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
    }
  }
  
  private void setRound(Round round) throws SQLException, ChessPairerException {
    editResultsPanel.setRound(round);
    alphabeticalPairingPanel.setRound(round);
    standingsPanel.setRound(round);
    jComboBoxRounds.setSelectedItem(round);
    Vector<Club> currentClubs = new Vector<Club>();
    if (currentTournament != null) {
      currentClubs = currentTournament.getCurrentClubList();
    }
    clubStandingsPanel.setRound(round, currentClubs);
    chess4StandingsPanel.setRound(round, currentClubs);
    updatePanels();
  }
  
  private void jComboBoxRounds_itemStateChanged(ItemEvent e) {
    try {
      setRound((Round)e.getItem());
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
    catch (ChessPairerException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void this_windowClosing() {
    fileExit_ActionPerformed();
  }

  private void jMenuItemDeletePair_actionPerformed() {
    editResultsPanel.deleteSelectedPair();
  }

  private void jMenuItemAppendPair_actionPerformed() {
    try {
			Game game = editResultsPanel.appendPair();
      EditPairDialog dlg = new EditPairDialog((Round)jComboBoxRounds.getSelectedItem());
      dlg.setGame(game);
      dlg.setLocationRelativeTo(this);
      dlg.setVisible(true);
      editResultsPanel.repaint();
    }
    catch (SQLException f) {
      JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      System.exit(0);
    }
    catch (ChessPairerException f) {
      JOptionPane.showMessageDialog(this, f.getMessage(), "Kan inte lgga till bord", JOptionPane.ERROR_MESSAGE);
    }
  }

  void jMenuItemEditPair_actionPerformed() {
    EditPairDialog dlg = new EditPairDialog((Round)jComboBoxRounds.getSelectedItem());
		Game game = editResultsPanel.getGame();
    if (game != null) {
      dlg.setGame(game);
      dlg.setLocationRelativeTo(this);
      dlg.setVisible(true);
      editResultsPanel.repaint();
    }
    else {
      JOptionPane.showMessageDialog(this, "Vlj ett bord frst", "Kan inte ndra bord", JOptionPane.INFORMATION_MESSAGE);
    }
  }

  private void jMenuItemPrintStandings_actionPerformed() {
    try {
      standingsPanel.print();
    }
    catch (PrinterException f) {
      JOptionPane.showMessageDialog(this, "Kan inte skriva ut stllning. Meddelande:" + f.getMessage(), "Kan inte skriva ut", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jMenuItemPrintPairing_actionPerformed() {
    try {
      editResultsPanel.print();
    }
    catch (PrinterException f) {
      JOptionPane.showMessageDialog(this, "Kan inte skriva ut resultat. Meddelande:" + f.getMessage(), "Kan inte skriva ut", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jMenuItemPublishStandings_actionPerformed() {
		HTMLStandings htmlStandings = new HTMLStandings();
		try {
			htmlStandings.publish(standingsPanel);
		}
	  catch (Exception e) {
	    JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
	  }
	}

  private void jMenuItemPublishPairing_actionPerformed() {
		HTMLPairings htmlPairings = new HTMLPairings();
		try {
			htmlPairings.publish(editResultsPanel);
		}
		catch (Exception e) {
		  JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
		}
	}

  private void jMenuItemSettings_actionPerformed() {
		SettingsDialog dlg = new SettingsDialog(settings, icon);
    dlg.setLocationRelativeTo(this);
    dlg.setVisible(true);
    if (dlg.isOk()) {
      try {
        settings.setPlayerPresentation(dlg.getPlayerPresentation());
				settings.setNrOfRows(dlg.getNrOfRows());
        settings.setMaxPointsImmediately(dlg.getMaxPointsImmediately());
        settings.setShowLASK(dlg.getShowLASK());
        settings.setShowELO(dlg.getShowELO());
        settings.setSearchForUpdate(dlg.getSearchForUpdate());
      }
      catch (SQLException f) {
        JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
    }
    updatePanels();
  }

  private void jMenuItemPrintPlayerList_actionPerformed() {
    try {
      playerListPanel.print();
    }
    catch (PrinterException f) {
      JOptionPane.showMessageDialog(this, "Kan inte skriva ut spelarlista. Meddelande:" + f.getMessage(), "Kan inte skriva ut", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jMenuItemPublishPlayerList_actionPerformed() {
		HTMLPlayerList html = new HTMLPlayerList();
		try {
			html.publish(playerListPanel);
		}
	  catch (Exception e) {
	    JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
	  }
	}

  private void jMenuItemPublishRounds_actionPerformed() {
    if (currentTournament != null) {
			HTMLRounds html = new HTMLRounds();
			try {
				html.publish(currentTournament);
			}
		  catch (Exception e) {
		    JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
		  }
		}
  }

  private void jMenuItemPrintClubStandings_actionPerformed() {
    try {
      clubStandingsPanel.print();
    }
    catch (PrinterException f) {
      JOptionPane.showMessageDialog(this, "Kan inte skriva ut klubbstllning. Meddelande:" + f.getMessage(), "Kan inte skriva ut", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jMenuItemPublishClubStandings_actionPerformed() {
		HTMLClubStandings htmlClubStandings = new HTMLClubStandings();
		try {
			htmlClubStandings.publish(clubStandingsPanel);
		}
	  catch (Exception e) {
	    JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
	  }
	}
  
  private void setChess4(Tournament tournament) {
    jTabbedPane.remove(clubStandingsPanel);
    jTabbedPane.remove(chess4SetupPanel);
    jTabbedPane.remove(chess4StandingsPanel);
    if (tournament != null) {
      jMenuItemPrintClubStandings.setVisible(!tournament.isChess4());
      jMenuItemPublishClubStandings.setVisible(!tournament.isChess4());
      jMenuItemPrintChess4Standings.setVisible(tournament.isChess4());
      jMenuItemPublishChess4Standings.setVisible(tournament.isChess4());
      if (tournament.isChess4()) {
        jTabbedPane.addTab("Schack4an instllningar klasstorlek", chess4SetupPanel);
				chess4SetupPanel.setTournament(tournament);
        jTabbedPane.addTab("Schack4an stllning", chess4StandingsPanel);
      }
      else {
        jTabbedPane.addTab("Klubbstllning", clubStandingsPanel);
      }
    }
    else {
      jTabbedPane.addTab("Klubbstllning", clubStandingsPanel);
    }
  }

  private void jMenuItemPrintChess4Standings_actionPerformed() {
    try {
      chess4StandingsPanel.print();
    }
    catch (PrinterException f) {
      JOptionPane.showMessageDialog(this, "Kan inte skriva ut Schack4an stllning. Meddelande:" + f.getMessage(), "Kan inte skriva ut", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jMenuItemPublishChess4Standings_actionPerformed() {
		HTMLChess4Standings htmlChess4Standings = new HTMLChess4Standings();
		try {
			htmlChess4Standings.publish(chess4StandingsPanel);
		}
	  catch (Exception e) {
	    JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
	  }
	}

  private void jMenuItemExport_actionPerformed() {
    // Get filename to export to
    if (currentTournament != null) {
      JFileChooser chooser = new JFileChooser();
      int returnVal = chooser.showSaveDialog(this);
      if(returnVal == JFileChooser.APPROVE_OPTION) {
        try {
          File file = chooser.getSelectedFile();
          if (file.exists()) {
            if (JOptionPane.showConfirmDialog(this, "Filen finns redan. Vill du skriva ver den?", "Bekrfta skriva ver fil", JOptionPane.YES_NO_OPTION, JOptionPane.QUESTION_MESSAGE) == JOptionPane.OK_OPTION) {
              file.delete();
            }
            else {
              return;
            }
          }
          file.createNewFile();
          // Save players in the file
          FileWriter writer = new FileWriter(file);
					Players players = currentTournament.getPlayers();
          for (int i=0; i<players.size(); i++) {
            export(writer, players.get(i));
          }
          writer.close();
        }
        catch (IOException f) {
          JOptionPane.showMessageDialog(this, "Kan inte exportera spelare till fil:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
        }
      }
    }
    else {
      JOptionPane.showMessageDialog(this, "Ingen turnering vald.", "Information", JOptionPane.INFORMATION_MESSAGE);
    }

  }

  private void jMenuItemImport_actionPerformed() {
    JFileChooser chooser = new JFileChooser();
    int returnVal = chooser.showOpenDialog(this);
    if(returnVal == JFileChooser.APPROVE_OPTION) {
      try {
        File file = chooser.getSelectedFile();
        if (file.exists()) {
          // Create players from the file
          FileReader fr = new FileReader(file);
          BufferedReader br = new BufferedReader(fr); 
          String str;
          Players availablePlayers = new Players(settings);
          availablePlayers.load();
          Vector<Player> newPlayers = new Vector<Player>();
          while((str = br.readLine()) != null) {
						Player player = importPlayer(str);
            if (availablePlayers.getPlayer(player.getFirstName().trim(), player.getLastName().trim(), player.getClub()) == null) {
              newPlayers.add(player);
            }
          }
          // Add the new players to the DB
          for (int i=0; i<newPlayers.size(); i++) {
						Player player = newPlayers.get(i);
            player.addToAvailablePlayers();
          }
          JOptionPane.showMessageDialog(this, newPlayers.size() + " nya spelare tillagda som tillgngliga spelare.", "Resultat import", JOptionPane.INFORMATION_MESSAGE);
          fr.close();
          return;
        }
      }
      catch (FileNotFoundException f) {
        JOptionPane.showMessageDialog(this, f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
      catch (IOException f) {
        JOptionPane.showMessageDialog(this, f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
      catch (SQLException f) {
        JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
      }
      catch (NoSuchElementException f) {
        JOptionPane.showMessageDialog(this, f.getMessage() + "Fel vid lsning av importfil. Ordningen p vrden mste vara EFTERNAMN FRNAMN KLUBB TITEL RATINGN och vara tabbseparerad. TITEL och RATINGN behver ej anges", "Fel", JOptionPane.ERROR_MESSAGE);
      }
    }
  }

  private void export(FileWriter writer, Player player) throws IOException {
    String str = String.format("%s\t%s\t%s\t%s\t%d\r\n", player.getLastName() ,player.getFirstName(), player.getClub(), player.getTitle(), player.getRatingN());
    writer.write(str);
  }


  private Player importPlayer(String str) throws NoSuchElementException, SQLException {
    try {
			Player player = new Player(settings);
      Scanner sc = new Scanner(str).useDelimiter("\t");
      player.setLastName(sc.next());
      player.setFirstName(sc.next());
      String clubName = sc.next();
      // Create club in DB if it doesnt exist
			Clubs clubs = settings.getClubs();
			Club club = clubs.getClub(clubName);
      if (club == null) {
        clubs.addToDB(clubName);
        club = clubs.getClub(clubName);
      }
      player.setClub(club);
      if (sc.hasNext()) {
        player.setTitle(sc.next());
      }
      if (sc.hasNext()) {
        player.setRatingN(sc.nextInt());
      }
      return player;
    }
    catch (NoSuchElementException e) {
      throw new NoSuchElementException("Rad '" + str + "' r inte korrekt. ");
    }
    catch (SQLException e) {
      throw new SQLException("Rad '" + str + "' r inte korrekt. " + e.getMessage());
    }
  }

  private void jMenuItemPrintAlphabetical_actionPerformed() {
    try {
      alphabeticalPairingPanel.print();
    }
    catch (PrinterException f) {
      JOptionPane.showMessageDialog(this, "Kan inte skriva ut lottning. Meddelande:" + f.getMessage(), "Kan inte skriva ut", JOptionPane.ERROR_MESSAGE);
    }
  }

  /**
   * Updates the status bar
   */
  private void updateStatus() {
    statusBar.setText("");
    if (currentTournament != null) {
      statusBar.setText(statusBar.getText() + "Turnering: " + currentTournament.getName() + "  Grupp: " + currentTournament.getGroup());
      if (currentTournament.getCurrentRound() == null) {
        statusBar.setText(statusBar.getText() + "  Ej startad");  
      }
      else {
        statusBar.setText(statusBar.getText() + "  Rond " + currentTournament.getCurrentRound().getRoundNr() + "/" + currentTournament.getNrOfRounds());  
      }
    }
    jTabbedPane.repaint();
  }

  /**
   * Updates all panels
   */
  private void updatePanels() {
    alphabeticalPairingPanel.update();
    editResultsPanel.update();
    standingsPanel.update();
    clubStandingsPanel.update();
    chess4SetupPanel.update();
    chess4StandingsPanel.update();
    updateStatus();
    playerListPanel.update();
    if (availablePlayersDlg != null) {
      availablePlayersDlg.update();
    }
    if (tournamentPlayersDlg != null) {
      tournamentPlayersDlg.update();
    }
  }

	private void jMenuItemExportToLiveChess_actionPerformed() {
	  // Get filename to export to
	  Round round = editResultsPanel.getRound();
	  if (round != null) {
	    JFileChooser chooser = new JFileChooser();
	    int returnVal = chooser.showSaveDialog(this);
	    if(returnVal == JFileChooser.APPROVE_OPTION) {
	      try {
	        File file = chooser.getSelectedFile();
	        FileWriter writer = null;
	        if (file.exists()) {
						int ans = JOptionPane.showConfirmDialog(this, "Filen finns redan. Vill du skriva ver den (nej lgger till data till den)", "Bekrfta skriv ver fil", JOptionPane.YES_NO_CANCEL_OPTION, JOptionPane.QUESTION_MESSAGE);
	          if (ans == JOptionPane.OK_OPTION) {
	            file.delete();
	            file.createNewFile();
	            writer = new FileWriter(file);
	          }
						else if (ans == JOptionPane.CANCEL_OPTION){
	            return;
	          }
						else {
						  writer = new FileWriter(file, true);
						}
	        }
					else {
					  writer = new FileWriter(file);
					}
	        // Save players in the file
					round.exportToLiveChess(writer);
	        writer.close();
	      }
	      catch (IOException f) {
	        JOptionPane.showMessageDialog(this, "Kan inte exportera turnering till fil:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
	      }
			}
		}
	  else {
	    JOptionPane.showMessageDialog(this, "Ingen rond vald.", "Information", JOptionPane.INFORMATION_MESSAGE);
	  }
	}

	private void jMenuItemAlphabeticalPairing_actionPerformed(int columns) {
	  HTMLAlphabeticalPairings html = new HTMLAlphabeticalPairings(columns);
		try {
			html.publish(alphabeticalPairingPanel, settings.getNrOfRows());
		}
		catch (Exception e) {
		  JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte publicera", JOptionPane.ERROR_MESSAGE);
		}
	}

  Settings getSettings() {
    return settings;
  }

  private void jMenuItemReport_actionPerformed() {
    FIDEReport report = new FIDEReport(this);
    try {
      report.create(currentTournament);
    }
    catch (IOException e) {
      JOptionPane.showMessageDialog(this, e.getMessage(), "Kan inte skapa rapportfil", JOptionPane.ERROR_MESSAGE);
    }
  }

  private void jMenuItemUpdate_actionPerformed() {
    SwingUtilities.invokeLater(new Update(aboutPanel.getVersion(), settings, false));
  }
}
