package cp.gui;

import cp.db.Settings;
import cp.db.Settings.PlayerPresentation;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import javax.swing.DefaultComboBoxModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.SpinnerNumberModel;

public class SettingsDialog extends JDialog {
  private boolean ok = false;
  private Settings settings;
  private JPanel jPanel1 = new JPanel();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JPanel jPanel2 = new JPanel();
  private JButton jButtonOk = new JButton();
  private JButton jButtonCancel = new JButton();
  private JLabel jLabel1 = new JLabel();
  private GridBagLayout gridBagLayout1 = new GridBagLayout();
  DefaultComboBoxModel model = new DefaultComboBoxModel();
  private JComboBox jComboBoxPlayerPresentation = new JComboBox(model);
	private JLabel jLabel2 = new JLabel();
	private JSpinner jSpinner = new JSpinner();
	private JLabel jLabel3 = new JLabel();
	private JLabel jLabel4 = new JLabel();
  private JCheckBox jCheckBoxMaxPoints = new JCheckBox();
  private JCheckBox jCheckBoxLASK = new JCheckBox();
  private JCheckBox jCheckBoxELO = new JCheckBox();
  private JCheckBox jCheckBoxUpdate = new JCheckBox();

  public SettingsDialog(Settings settings, Image icon) {
    super();
    this.settings = settings;
    this.setIconImage(icon);
    try {
      jbInit();
      PlayerPresentation pres = settings.getPlayerPresentation();
      jComboBoxPlayerPresentation.setSelectedIndex(pres.ordinal());
			int rows = settings.getNrOfRows();
			if (rows == Integer.MAX_VALUE) {
				jSpinner.setValue(0);
			}
			else {	
				jSpinner.setValue(rows);
			}
      jCheckBoxMaxPoints.setSelected(settings.getMaxPointsImmediately());
      jCheckBoxLASK.setSelected(settings.getShowLASK());
      jCheckBoxELO.setSelected(settings.getShowELO());
      jCheckBoxUpdate.setSelected(settings.getSearchForUpdate());
    }
    catch (Exception e) {
      e.printStackTrace();
    }
    pack();
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    this.setTitle("Instllningar");
    this.setModal(true);
    jPanel1.setLayout(gridBagLayout1);
    jButtonOk.setText("OK");
    jButtonOk.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonOk_actionPerformed();
        }
      });
    jButtonCancel.setText("Avbryt");
    jButtonCancel.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonCancel_actionPerformed();
        }
      });
    jLabel1.setText("Namnvisning");
		jLabel2.setText("Radbryt publicerad alfabetisk");
		jLabel3.setText("lottningslista efter s hr mnga rader");
		jLabel4.setText("(0=radbryt aldrig)");
    jCheckBoxMaxPoints.setText("Stt maxpong per match omedelbart");
    jCheckBoxMaxPoints.setToolTipText("Om maxpong=4, tryck 3 stter resultatet till 3-1. Annars, stt resultat genom att trycka 1 och 0");
    jCheckBoxMaxPoints.setSelected(true);
    jCheckBoxLASK.setText("Visa LASK-rating");
    jCheckBoxELO.setText("Visa ELO-rating");
    jCheckBoxUpdate.setText("Sk efter uppdateringar vid start");
    jPanel1.add(jLabel1, new GridBagConstraints(0, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
    jPanel1.add(jComboBoxPlayerPresentation, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE, new Insets(5, 5, 0, 5), 0, 0));
		jPanel1.add(jLabel2, new GridBagConstraints(0, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 5, 0, 0), 0, 0));
		jPanel1.add(jSpinner, new GridBagConstraints(1, 1, 1, 3, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(10, 5, 0, 5), 0, 0));
		jPanel1.add(jLabel3, new GridBagConstraints(0, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
		jPanel1.add(jLabel4, new GridBagConstraints(0, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel1.add(jCheckBoxMaxPoints, new GridBagConstraints(0, 4, 2, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(10, 5, 5, 0), 0, 0));
    jPanel1.add(jCheckBoxLASK, new GridBagConstraints(0, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 5, 0), 0, 0));
    jPanel1.add(jCheckBoxELO, new GridBagConstraints(0, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 5, 0, 0), 0, 0));
    jPanel1.add(jCheckBoxUpdate, new GridBagConstraints(0, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(12, 5, 0, 0), 0, 0));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel2.add(jButtonOk, null);
    jPanel2.add(jButtonCancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    model.addElement("Frnamn efternamn");
    model.addElement("Efternamn frnamn");
		jSpinner.setModel(new SpinnerNumberModel(0, 0, 100, 1));
}

  private void jButtonCancel_actionPerformed() {
    this.setVisible(false);
  }

  private void jButtonOk_actionPerformed() {
    ok = true;
    this.setVisible(false);
  }
  
  public boolean isOk() {
    return ok;
  }
  
  public PlayerPresentation getPlayerPresentation() {
    return Settings.PlayerPresentation.values()[jComboBoxPlayerPresentation.getSelectedIndex()];
  }

	int getNrOfRows() {
		int value = (Integer) jSpinner.getValue();
		if (value == 0) {
			return Integer.MAX_VALUE;
		}
		return value;
	}

  boolean getMaxPointsImmediately() {
    return jCheckBoxMaxPoints.isSelected();
  }

  boolean getShowLASK() {
    return jCheckBoxLASK.isSelected();
  }

  boolean getShowELO() {
    return jCheckBoxELO.isSelected();
  }

  boolean getSearchForUpdate() {
    return jCheckBoxUpdate.isSelected();
  }
}
