package cp.gui;

import cp.Tournament;
import cp.db.Settings;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.sql.SQLException;
import javax.swing.DefaultButtonModel;
import javax.swing.JButton;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSpinner;
import javax.swing.JTextField;
import javax.swing.SpinnerModel;
import javax.swing.SpinnerNumberModel;

public class TournamentDialog extends JDialog {
  private JLabel jLabel1 = new JLabel();
  private JTextField jTextFieldName = new JTextField();
  private JLabel jLabel2 = new JLabel();
  private JTextField jTextFieldGroup = new JTextField();
  private JLabel jLabel3 = new JLabel();
  private JComboBox jComboBoxPairingSystem = new JComboBox();
  private JComboBox jComboBoxInitialPairing = new JComboBox();
  private JSpinner jSpinnerRounds = new JSpinner();
  private JCheckBox jCheckBoxBarred = new JCheckBox();
  private JPanel jPanel1 = new JPanel();
  private JPanel jPanel2 = new JPanel();
  private GridBagLayout gridBagLayout2 = new GridBagLayout();
  private BorderLayout borderLayout1 = new BorderLayout();
  private JButton jButtonOK = new JButton();
  private JButton jButtonCancel = new JButton();
  private JLabel jLabel4 = new JLabel();
  private JLabel jLabel5 = new JLabel();
  private JLabel jLabel6 = new JLabel();
  private JLabel jLabel7 = new JLabel();
  private Tournament tournament;
  private JTextField jTextFieldResults = new JTextField();
  private JLabel jLabel8 = new JLabel();
  private JTextField jTextFieldStandings = new JTextField();
  private JLabel jLabel9 = new JLabel();
  private Settings settings;
  private JLabel jLabel10 = new JLabel();
  private JTextField jTextFieldPlayerList = new JTextField();
  private JLabel jLabel12 = new JLabel();
  private JTextField jTextFieldRoundForRound = new JTextField();
  private JLabel jLabel13 = new JLabel();
  private JSpinner jSpinnerPoints = new JSpinner();
  private TournamentDialogTiebreak jPanelTiebreak = new TournamentDialogTiebreak();
  private JCheckBox jCheckBoxCompensateWeakPlayerPP = new JCheckBox();
  private JLabel jLabel15 = new JLabel();
  private JLabel jLabel16 = new JLabel();
  private JCheckBox jCheckBoxChess4 = new JCheckBox();
  private JLabel jLabel17 = new JLabel();
  private JLabel jLabel18 = new JLabel();
  private JTextField jTextFieldClubStandings = new JTextField();
  private JLabel jLabel19 = new JLabel();
  private JLabel jLabel20 = new JLabel();

  public TournamentDialog(Settings settings, Image icon) {
    super();
    this.settings = settings;
    this.setIconImage(icon);
    try {
      jbInit();
    }
    catch (Exception e) {
      e.printStackTrace();
    }
  }

  private void jbInit() throws Exception {
    this.getContentPane().setLayout(borderLayout1);
    this.setModal(true);
    jLabel1.setText("Turnering");
    jLabel2.setText("Grupp");
    jLabel3.setText("Lottningssystem");
    jSpinnerRounds.setPreferredSize(new Dimension(40, 20));
    jSpinnerPoints.setPreferredSize(new Dimension(40, 20));
    jCheckBoxBarred.setToolTipText("Om denna r vald kommer medlemmar i samma klubb inte att mtas");
    jPanel1.setLayout(gridBagLayout2);
    jButtonOK.setText("Spara");
    jButtonOK.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonOK_actionPerformed(e);
        }
      });
    jButtonCancel.setText("Avbryt");
    jButtonCancel.addActionListener(new ActionListener() {
        public void actionPerformed(ActionEvent e) {
          jButtonCancel_actionPerformed(e);
        }
      });
    jLabel4.setText("Srskiljning");
    jLabel5.setText("Initial spelarordning");
    jLabel6.setText("Antal ronder");
    jLabel7.setText("Lt ej spelare frn");
    jLabel20.setText("samma klubb mtas");
    jLabel8.setText("Lottning html-fil");
    jLabel9.setText("Stllning html-fil");
    jLabel10.setText("Spelarlista html-fil");
    jLabel12.setText("Round for round html-fil");
    jLabel13.setText("Pong per match");
    jPanel1.add(jLabel1, new GridBagConstraints(1, 0, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jTextFieldName, new GridBagConstraints(4, 0, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel2, new GridBagConstraints(1, 1, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jTextFieldGroup, new GridBagConstraints(4, 1, 3, 1, 1.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel3, new GridBagConstraints(1, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jComboBoxPairingSystem, new GridBagConstraints(4, 2, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 0), 50, 0));
    jPanel1.add(jComboBoxInitialPairing, new GridBagConstraints(4, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 0), 50, 0));
    jPanel1.add(jSpinnerRounds, new GridBagConstraints(4, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanel1.add(jCheckBoxBarred, new GridBagConstraints(4, 6, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel4, new GridBagConstraints(1, 3, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanel1.add(jLabel5, new GridBagConstraints(1, 4, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jLabel6, new GridBagConstraints(1, 5, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jLabel7, new GridBagConstraints(1, 6, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jTextFieldResults, new GridBagConstraints(4, 12, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel8, new GridBagConstraints(1, 12, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jTextFieldStandings, new GridBagConstraints(4, 13, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel9, new GridBagConstraints(1, 13, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanel1.add(jLabel10, new GridBagConstraints(1, 14, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanel1.add(jTextFieldPlayerList, new GridBagConstraints(4, 14, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel12, new GridBagConstraints(1, 15, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 5), 0, 0));
    jPanel1.add(jTextFieldRoundForRound, new GridBagConstraints(4, 15, 3, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel13, new GridBagConstraints(1, 10, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanel1.add(jSpinnerPoints, new GridBagConstraints(4, 10, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    this.getContentPane().add(jPanel1, BorderLayout.CENTER);
    jPanel2.add(jButtonOK, null);
    jPanel2.add(jButtonCancel, null);
    this.getContentPane().add(jPanel2, BorderLayout.SOUTH);
    jButtonCancel.setModel(new DefaultButtonModel());
    // Insert values in comboboxes
    jComboBoxPairingSystem.addItem("Berger");
    jComboBoxPairingSystem.addItem("Monrad");
    jComboBoxPairingSystem.addItem("Nordisk Schweizer");
    jComboBoxPairingSystem.setSelectedIndex(2);
    jComboBoxInitialPairing.addItem("Slumpad");
    jComboBoxInitialPairing.addItem("Rating");
    jComboBoxInitialPairing.setSelectedIndex(1);
    SpinnerModel modelRounds = new SpinnerNumberModel(9, 0, 1000, 1);
    jSpinnerRounds.setModel(modelRounds);
    SpinnerModel modelPoints = new SpinnerNumberModel(1, 1, 100, 1);
    jSpinnerPoints.setModel(modelPoints);
    jCheckBoxCompensateWeakPlayerPP.setToolTipText("Nr ett parti r uppskjutet rknas resultatet som remi fr den svagare spelare om ratingskillnaden r > 200p. Annars rknas det som vinst fr bda.");
    jLabel15.setText("som remi fr den svagare");
    jLabel16.setText("Rkna uppskjutna partier");
    jLabel17.setText("Visa Schack4an-flikar");
    jLabel18.setText("Klubbstllning html-fil");
    jLabel19.setText("(Schack4an stllning)");
    jPanel1.add(jPanelTiebreak, new GridBagConstraints(4, 3, 2, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jCheckBoxCompensateWeakPlayerPP, new GridBagConstraints(4, 8, 1, 2, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel15, new GridBagConstraints(1, 9, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    jPanel1.add(jLabel16, new GridBagConstraints(1, 8, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 10), 0, 0));
    jPanel1.add(jCheckBoxChess4, new GridBagConstraints(4, 11, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 0, 0, 0), 0, 0));
    jPanel1.add(jLabel17, new GridBagConstraints(1, 11, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanel1.add(jLabel18, new GridBagConstraints(1, 16, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(8, 10, 0, 0), 0, 0));
    jPanel1.add(jTextFieldClubStandings, new GridBagConstraints(4, 16, 3, 2, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.HORIZONTAL, new Insets(8, 0, 0, 20), 0, 0));
    jPanel1.add(jLabel19, new GridBagConstraints(1, 17, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 0), 0, 0));
    jPanel1.add(jLabel20, new GridBagConstraints(1, 7, 1, 1, 0.0, 0.0, GridBagConstraints.WEST, GridBagConstraints.NONE, new Insets(0, 10, 0, 10), 0, 0));
    pack();
  }

  private void jButtonOK_actionPerformed(ActionEvent e) {
    if (!jTextFieldName.getText().isEmpty() && !jTextFieldGroup.getText().isEmpty()) {
      if (jButtonOK.getText().equals("Spara")) {
        tournament = new Tournament(settings);
        tournament.setName(jTextFieldName.getText());
        tournament.setGroup(jTextFieldGroup.getText());
      }
      tournament.setPairingSystem((String) jComboBoxPairingSystem.getSelectedItem());
      tournament.setTiebreaks(jPanelTiebreak.getTiebreaks());
      tournament.setInitialPairing((String) jComboBoxInitialPairing.getSelectedItem());
      tournament.setNrOfRounds((Integer) jSpinnerRounds.getValue());
      tournament.setBarredPairing(jCheckBoxBarred.isSelected());
      tournament.setCompensateWeakPlayerPP(jCheckBoxCompensateWeakPlayerPP.isSelected());
      tournament.setPointsPerGame((Integer) jSpinnerPoints.getValue());
      tournament.setIsChess4(jCheckBoxChess4.isSelected());
      if (!jTextFieldResults.getText().isEmpty()) {
        tournament.setResultsPage(jTextFieldResults.getText());
      }
      else {
        tournament.setResultsPage(null);
      }
      if (!jTextFieldStandings.getText().isEmpty()) {
        tournament.setStandingsPage(jTextFieldStandings.getText());
      }
      else {
        tournament.setStandingsPage(null);
      }
      if (!jTextFieldPlayerList.getText().isEmpty()) {
        tournament.setPlayerListPage(jTextFieldPlayerList.getText());
      }
      else {
        tournament.setPlayerListPage(null);
      }
      if (!jTextFieldRoundForRound.getText().isEmpty()) {
        tournament.setRoundForRoundPage(jTextFieldRoundForRound.getText());
      }
      else {
        tournament.setRoundForRoundPage(null);
      }
      if (!jTextFieldClubStandings.getText().isEmpty()) {
        tournament.setClubStandingsPage(jTextFieldClubStandings.getText());
      }
      else {
        tournament.setClubStandingsPage(null);
      }
      try {
        if (jButtonOK.getText().equals("Uppdatera")) {
          tournament.update();
        }
        else {
          tournament.save();
        }
        this.setVisible(false);
      }
      catch (SQLException f) {
        if (f.getMessage().contains("duplicate key value")) {
          JOptionPane.showMessageDialog(this, "Turneringen finns redan.", "Information", JOptionPane.INFORMATION_MESSAGE);
        }
        else {
          JOptionPane.showMessageDialog(this, "SQL fel:" + f.getMessage(), "Fel", JOptionPane.ERROR_MESSAGE);
        }
      }
    }
    else {
      JOptionPane.showMessageDialog(this, "Vnligen ange turneringsnamn och grupp.", "Message", JOptionPane.INFORMATION_MESSAGE);
    }
  }

  public Tournament getTournament() {
    return tournament;
  }
  
  private void jButtonCancel_actionPerformed(ActionEvent e) {
    this.setVisible(false);
  }
  
  public void setTournament(Tournament tournament) {
    this.tournament = tournament;
    // Fill in fields and show update mode
    jTextFieldName.setText(tournament.getName());
    jTextFieldName.setEnabled(false);
    jTextFieldGroup.setText(tournament.getGroup());
    jTextFieldGroup.setEnabled(false);
    jComboBoxPairingSystem.setSelectedItem(tournament.getPairingSystem());
    // Set up tiebreak
    jPanelTiebreak.setTiebreaks(tournament.getTiebreaks());
    
    jComboBoxInitialPairing.setSelectedItem(tournament.getInitialPairing());
    jSpinnerRounds.setValue(tournament.getNrOfRounds());
    jCheckBoxBarred.setSelected(tournament.isBarredPairing());
    jCheckBoxCompensateWeakPlayerPP.setSelected(tournament.isCompensateWeakPlayerPP());
    jCheckBoxChess4.setSelected(tournament.isChess4());
    jSpinnerPoints.setValue(tournament.getPointsPerGame());
    if (tournament.getResultsPage() != null) {
      jTextFieldResults.setText(tournament.getResultsPage());
    }
    else {
      jTextFieldResults.setText("");
    }
    if (tournament.getStandingsPage() != null) {
      jTextFieldStandings.setText(tournament.getStandingsPage());
    }
    else {
      jTextFieldStandings.setText("");
    }
    if (tournament.getPlayerListPage() != null) {
      jTextFieldPlayerList.setText(tournament.getPlayerListPage());
    }
    else {
      jTextFieldPlayerList.setText("");
    }
    if (tournament.getRoundForRoundPage() != null) {
      jTextFieldRoundForRound.setText(tournament.getRoundForRoundPage());
    }
    else {
      jTextFieldRoundForRound.setText("");
    }
    if (tournament.getClubStandingsPage() != null) {
      jTextFieldClubStandings.setText(tournament.getClubStandingsPage());
    }
    else {
      jTextFieldClubStandings.setText("");
    }
    jButtonOK.setText("Uppdatera");
  }
}
