package cp.gui.web;

import cp.*;
import java.io.*;
import javax.swing.*;
import javax.swing.filechooser.*;

public class FIDEReport {
  private JFrame parent;

  public FIDEReport(JFrame parent) {
    this.parent = parent;
  }

  public void create(Tournament tournament) throws IOException {
    JFileChooser fc = new JFileChooser(); 
    FileNameExtensionFilter filter = new FileNameExtensionFilter("FIDE exchange format", "txt");
    fc.setFileFilter(filter);
    if (fc.showSaveDialog(parent) == JFileChooser.APPROVE_OPTION) {
      File file = fc.getSelectedFile();
      PrintWriter writer;
      writer = new PrintWriter(new FileWriter(file));
      writeTournamentSection(tournament, writer);
      writePlayerSection(tournament, writer);
      writer.close(); 
    }
  }

  private void writeTournamentSection(Tournament tournament, PrintWriter writer) {
    writer.println(String.format("012 %s", toEnglish(tournament.getName())));
/*    writer.println(String.format("022 %s\n", toEnglish(tournament.getCity())));
    writer.println(String.format("032 %s\n", "SWE"));
    writer.println(String.format("042 %s\n", tournament.getStartDate()));
    writer.println(String.format("052 %s\n", tournament.getEndDate()));
    writer.println(String.format("062 %s", tournament.getPlayers().size()));
    writer.println(String.format("072 %s\n", tournament.getPlayers().getNrOfELOPlayers()));
    writer.println(String.format("092 %s\n", tournament.getTypeOfTournament()));
    writer.println(String.format("102 %s\n", toEnglish(tournament.getChiefArbiter())));
    writer.println(String.format("112 %s\n", toEnglish(tournament.getDeputyArbiter())));
    writer.println(String.format("122 %s\n", tournament.getTimePerGame());*/
  }

  private void writePlayerSection(Tournament tournament, PrintWriter writer) {
  }

  private String toEnglish(String string) {
    string = string.replace('', 'a');
    string = string.replace('', 'a');
    return string.replace('', 'a');
  }
}
