package cp.gui.web;

import cp.Round;
import cp.Tournament;

import cp.gui.ClubStandingsPanel;

import java.io.FileNotFoundException;
import java.io.IOException;
import javax.swing.JOptionPane;
import javax.xml.parsers.*;
import javax.xml.transform.*;
import org.w3c.dom.*;

public class HTMLClubStandings extends HTMLPairings {

  public HTMLClubStandings() {}
  
  public void publish(ClubStandingsPanel clubStandingsPanel) throws FileNotFoundException, IOException {
    // Create output html file
		Round round = clubStandingsPanel.getRound();
		Tournament tournament = round.getTournament();
    String fileName = tournament.getClubStandingsPage();
    if (fileName != null) {
      try {
        // Create document
        Document document = createDocument();
        Element html = document.createElement("html");
        document.appendChild(html);
        // Create title
        Element head = document.createElement("head");
        html.appendChild(head);
        Element title = document.createElement("title");
        head.appendChild(title);
        Text text = document.createTextNode("Klubbstllning " + tournament);
        title.appendChild(text);
				// Create stylesheet
				appendStylesheet(document, head);
        // Create body
        Element body = document.createElement("body");
        html.appendChild(body);
        text = document.createTextNode("Lotta - Klubbstllning fr turnering " + tournament + " efter rond " + round.getRoundNr());
        body.appendChild(text);
        
        // Save the table
        clubStandingsPanel.save(document, body);
        
        // Save the file
        save(document, fileName);
      }
      catch (ParserConfigurationException e) {
        JOptionPane.showMessageDialog(null, "ParserConfigurationException:" + e.getMessage(), "Can't create file", JOptionPane.ERROR_MESSAGE);
      }
      catch (TransformerConfigurationException e) {
        JOptionPane.showMessageDialog(null, "Resultatfil kan inte ppnas eller skapas. Meddelande:" + e.getMessage(), "Can't open file", JOptionPane.ERROR_MESSAGE);
      }
      catch (TransformerException e) {
        JOptionPane.showMessageDialog(null, "Resultatfil kan inte ppnas eller skapas. Meddelande:" + e.getMessage(), "Can't open file", JOptionPane.ERROR_MESSAGE);
      }
    }
    else {
      JOptionPane.showMessageDialog(null, "Du mste ange ett namn fr html-filen i turneringsdialogen fr att kunna publicera den.", "Ingen html-fil specificerad", JOptionPane.INFORMATION_MESSAGE);
    }
  }
}
