package cp.tiebreak;

import cp.Player;
import cp.Tournament;

import cp.db.DB;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Statement;

import java.util.Collection;
import java.util.Vector;

public class Tiebreaks {
  private Vector<Tiebreak> available = new Vector<Tiebreak>();
  private Vector<Tiebreak> selected = new Vector<Tiebreak>();
  
  public Tiebreaks() {
    super();
    available.add(new cp.tiebreak.TiebreakBerger());
    available.add(new TiebreakBuchholz());
    available.add(new cp.tiebreak.TiebreakMedianBuchholz());
    available.add(new cp.tiebreak.TiebreakSSFBuchholz());
    available.add(new TiebreakProgressive());
    available.add(new cp.tiebreak.TiebreakManual());
  }

  public void load(Tournament tournament) throws SQLException {
    Connection conn = DB.getConnection();
    Statement s = conn.createStatement();
    String sql = "SELECT * FROM tournamenttiebreaks " + "WHERE tournamentindex = " + tournament.getIndex();
    ResultSet rs = s.executeQuery(sql);
    while (rs.next()) {
      select(rs.getString("tiebreak"));
    }
    s.close();
  }
  
  public void select(String tiebreak) {
    for (int i = 0; i < available.size(); i++) {
      Tiebreak tb = available.get(i);
      if (tb.toString().equals(tiebreak)) {
        available.remove(tb);
        selected.add(tb);
        return;
      }
    }
  }

  public void unselect(String tiebreak) {
    for (int i=0; i<selected.size(); i++) {
      Tiebreak tb = selected.get(i);
      if (tb.toString().equals(tiebreak)) {
        selected.remove(tb);
        available.add(tb);
        return;
      }
    }
  }

  public Vector<Tiebreak> getAvailableTiebreaks() {
    return available;
  }
  
  public Vector<Tiebreak> getSelectedTiebreaks() {
    return selected;
  }
}
